"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.updatedKeysComposite = exports.updatedKeysCollection = exports.updatedKeys = exports.simpleKeysEqual = void 0;
var Util = _interopRequireWildcard(require("./util"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const simpleKeysEqual = (v1, v2) => {
  if (typeof v1 === "object" || typeof v2 === "object") {
    // debugger;
    if (JSON.stringify(v1) === JSON.stringify(v2)) {
      return true;
    }
  }
  if ((v1 === undefined || v1 === "") && (v2 === undefined || v2 === "") || v1 === v2) {
    return true;
  }
  return false;
};
exports.simpleKeysEqual = simpleKeysEqual;
const updatedKeysComposite = (newObj, oldObj, tdlKeys, modifiedValues) => {
  for (const key in tdlKeys) {
    if (tdlKeys[key].keyType === "Simple" && !simpleKeysEqual(newObj[tdlKeys[key].name], oldObj[tdlKeys[key].name]) || tdlKeys[key].isAssociation === true) {
      modifiedValues[tdlKeys[key].name] = newObj[tdlKeys[key].name];
    } else if (tdlKeys[key].keyType === "Composition") {
      const inModefication = {};
      if (oldObj[tdlKeys[key].name] === undefined) {
        oldObj[tdlKeys[key].name] = {};
      }
      if (newObj[tdlKeys[key].name] === undefined) {
        newObj[tdlKeys[key].name] = {};
      }
      updatedKeysComposite(newObj[tdlKeys[key].name], oldObj[tdlKeys[key].name], tdlKeys[key].subKeys, inModefication);
      modifiedValues[tdlKeys[key].name] = inModefication;
    } else if (tdlKeys[key].keyType === "Collection") {
      const inModefication = {};
      updatedKeysCollection(newObj[tdlKeys[key].name], oldObj[tdlKeys[key].name], tdlKeys[key].subKeys, inModefication);
      modifiedValues[tdlKeys[key].name] = inModefication;
    }
  }
};
exports.updatedKeysComposite = updatedKeysComposite;
const updatedKeysCollection = (newObj, oldObj, tdlKeys, modifiedValues) => {
  const PKs = Util.getClientPKS(newObj);
  for (const pk in PKs) {
    if (PKs[pk]) {
      let oldObject = Util.findObjInCollection(oldObj, PKs[pk]);
      const newObject = Util.findObjInCollection(newObj, PKs[pk]);
      if (oldObject === undefined) {
        oldObject = {};
      }
      const inModefication = {};
      updatedKeysComposite(newObject, oldObject, tdlKeys, inModefication);
      modifiedValues[PKs[pk]] = inModefication;
    }
    // } else {
    // 	newObject.pk=undefined;
    // 	modifiedValues[PKs[pk]] = newObject;
    // }
  }
};
exports.updatedKeysCollection = updatedKeysCollection;
const updatedKeys = (newObj, oldObj, tdlKeys, modifiedValues) => {
  if (tdlKeys.keyType === "Composition") {
    updatedKeysComposite(newObj, oldObj, tdlKeys.subKeys, modifiedValues);
  } else if (tdlKeys.keyType === "Collection") {
    updatedKeysCollection(newObj, oldObj, tdlKeys.subKeys, modifiedValues);
  }
};
exports.updatedKeys = updatedKeys;