"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.uploadFile = exports.setWarnings = exports.setTimezoneOffset = exports.setSuccessfulMessages = exports.setSidebarCollapsed = exports.setMainMenu = exports.setIsSessionInvalidated = exports.setIsRTL = exports.setIsLoading = exports.setFavoriteItems = exports.setErrors = exports.setCustomLoading = exports.setCurrentUser = exports.setCurrentPassword = exports.sendSearchRequest = exports.sendRequest = exports.sendRefreshWithoutUpdate = exports.sendRefreshRequest = exports.sendNewCollectionElement = exports.saveFilter = exports.requestCheckIntegrity = exports.requestBackTo = exports.requestBack = exports.removeFromFavorite = exports.login = exports.getRowsCount = exports.flipCountMode = exports.fetchMainMenu = exports.fetchFavoriteList = exports.fetchDashboardItems = exports.fetchDashboard = exports.exportReport = exports.executeAction = exports.downloadFile = exports.deleteFilter = exports.confirmAction = exports.closeUsecaseId = exports.checkSession = exports.cancelCollectionElement = exports.askForPossibleValue = exports.applyFilter = exports.addToFavorite = exports.SMSPagination = exports.Logout = exports.GENERAL_ACTION_TYPES = void 0;
const GENERAL_ACTION_TYPES = exports.GENERAL_ACTION_TYPES = {
  SET_IS_LOADING: "SET_IS_LOADING",
  SET_SUCCESSFUL_MESSAGES: "SET_SUCCESSFUL_MESSAGES",
  SET_WARNINGS: "SET_WARNINGS",
  SET_ERRORS: "SET_ERRORS",
  SET_CUSTOM_LOADING: "SET_CUSTOM_LOADING",
  SET_TIMEZONE_OFFSET: "SET_TIMEZONE_OFFSET",
  SET_IS_RTL: "SET_IS_RTL",
  SEND_REQUEST: "SEND_REQUEST",
  SET_CURRENT_USER: "CURRENT_USER",
  SET_CURRENT_PASSWORD: "CURRENT_PASSWORD",
  SET_IS_SESSION_INVALIDATED: "SET_IS_SESSION_INVALIDATED",
  GET_MAIN_MENU: "GET_MAIN_MENU",
  SET_SIDEBAR_COLLAPSED: "SET_SIDEBAR_COLLAPSED",
  SET_MAIN_MENU: "SET_MAIN_MENU",
  SET_FAVORITE_ITEMS: "SET_FAVORITE_ITEMS",
  UPLOAD_FILE: "UPLOAD_FILE",
  FETCH_FAVORITE_LIST: "FETCH_FAVORITE_LIST"
};
const setSuccessfulMessages = successfulMessages => {
  return {
    type: GENERAL_ACTION_TYPES.SET_SUCCESSFUL_MESSAGES,
    successfulMessages
  };
};
exports.setSuccessfulMessages = setSuccessfulMessages;
const setWarnings = warnings => {
  return {
    type: GENERAL_ACTION_TYPES.SET_WARNINGS,
    warnings
  };
};
exports.setWarnings = setWarnings;
const setErrors = errors => {
  console.log("Ok i ot those errors ", errors);
  return {
    type: GENERAL_ACTION_TYPES.SET_ERRORS,
    errors
  };
};
exports.setErrors = setErrors;
const setIsLoading = isLoading => {
  return {
    type: GENERAL_ACTION_TYPES.SET_IS_LOADING,
    isLoading
  };
};
exports.setIsLoading = setIsLoading;
const setCustomLoading = customLoading => {
  return {
    type: GENERAL_ACTION_TYPES.SET_CUSTOM_LOADING,
    customLoading
  };
};
exports.setCustomLoading = setCustomLoading;
const setTimezoneOffset = timeZoneOffset => ({
  type: GENERAL_ACTION_TYPES.SET_TIMEZONE_OFFSET,
  timeZoneOffset
});
exports.setTimezoneOffset = setTimezoneOffset;
const setIsRTL = isRTL => ({
  type: GENERAL_ACTION_TYPES.SET_IS_RTL,
  isRTL
});
exports.setIsRTL = setIsRTL;
const sendRequest = (options, context, auth, callback) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options,
  context,
  auth,
  callback
});
exports.sendRequest = sendRequest;
const setCurrentUser = currentUser => ({
  type: GENERAL_ACTION_TYPES.SET_CURRENT_USER,
  currentUser
});
exports.setCurrentUser = setCurrentUser;
const setCurrentPassword = currentPassword => ({
  type: GENERAL_ACTION_TYPES.SET_CURRENT_PASSWORD,
  currentPassword
});
exports.setCurrentPassword = setCurrentPassword;
const setIsSessionInvalidated = isSessionInvalidated => ({
  type: GENERAL_ACTION_TYPES.SET_IS_SESSION_INVALIDATED,
  isSessionInvalidated
});
exports.setIsSessionInvalidated = setIsSessionInvalidated;
const setSidebarCollapsed = sidebarCollapsed => ({
  type: GENERAL_ACTION_TYPES.SET_SIDEBAR_COLLAPSED,
  sidebarCollapsed
});
exports.setSidebarCollapsed = setSidebarCollapsed;
const setMainMenu = mainMenu => ({
  type: GENERAL_ACTION_TYPES.SET_MAIN_MENU,
  mainMenu
});
exports.setMainMenu = setMainMenu;
const setFavoriteItems = favorite => ({
  type: GENERAL_ACTION_TYPES.SET_FAVORITE_ITEMS,
  favorite
});
exports.setFavoriteItems = setFavoriteItems;
const login = (username, password, callback) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "login"
  },
  auth: {
    username,
    password
  },
  callback
});
exports.login = login;
const checkSession = function () {
  let callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  return {
    type: GENERAL_ACTION_TYPES.SEND_REQUEST,
    options: {
      tdlId: "checkSession"
    },
    context: {
      disableMessages: true
    },
    callback
  };
};
exports.checkSession = checkSession;
const fetchMainMenu = () => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "EDMS$$modeling$$-$$mainmenue",
    pageNumber: 0,
    rowsNumber: 1000000
  },
  context: {
    withLoader: false,
    closeUsecase: true
  }
});
exports.fetchMainMenu = fetchMainMenu;
const Logout = () => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "logout"
  }
});
exports.Logout = Logout;
const sendRefreshRequest = function (usecaseId) {
  let vsLoader = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  let callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  return {
    type: GENERAL_ACTION_TYPES.SEND_REQUEST,
    options: {
      tdlId: "refresh"
    },
    context: {
      usecaseId,
      vsLoader
    },
    callback
  };
};
exports.sendRefreshRequest = sendRefreshRequest;
const sendRefreshWithoutUpdate = function (usecaseId) {
  let callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  return {
    type: GENERAL_ACTION_TYPES.SEND_REQUEST,
    options: {
      tdlId: "refreshWithoutUpdate"
    },
    context: {
      usecaseId,
      vsLoader: true
    },
    callback
  };
};
exports.sendRefreshWithoutUpdate = sendRefreshWithoutUpdate;
const fetchDashboard = callback => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "CMS$$CMS$$-$$getUserDashBoards"
  },
  context: {
    withLoader: false,
    drawUsecaseId: false
  },
  callback
});
exports.fetchDashboard = fetchDashboard;
const fetchDashboardItems = (usecaseId, callback) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "CMS$$CMS$$com.elixir.cms.DashBoard.DashBoardSettings$$viewDashboardSetting"
  },
  context: {
    usecaseId,
    withLoader: false,
    closeUsecase: true,
    drawUsecaseId: false
  },
  callback
});
exports.fetchDashboardItems = fetchDashboardItems;
const closeUsecaseId = usecaseId => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "closeUseCase"
  },
  context: {
    usecaseId
  }
});
exports.closeUsecaseId = closeUsecaseId;
const SMSPagination = (usecaseId, pageNumber, callback, rowsNumber) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "search",
    pageNumber,
    rowsNumber
  },
  context: {
    usecaseId,
    vsLoader: true,
    withLoader: false
  },
  callback
});
exports.SMSPagination = SMSPagination;
const requestBackTo = (usecaseId, backToId) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "backTo",
    backtoId: backToId
  },
  context: {
    usecaseId,
    vsLoader: true,
    withLoader: false
  }
});
exports.requestBackTo = requestBackTo;
const requestBack = function (usecaseId) {
  let callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
  return {
    type: GENERAL_ACTION_TYPES.SEND_REQUEST,
    options: {
      tdlId: "back"
    },
    context: {
      usecaseId,
      vsLoader: true,
      withLoader: false
    },
    callback
  };
};
exports.requestBack = requestBack;
const executeAction = function (usecaseId, tdlId, responseType) {
  let callback = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
  let externalContext = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
  let otherOptions = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
  return {
    type: GENERAL_ACTION_TYPES.SEND_REQUEST,
    options: {
      tdlId,
      ...otherOptions
    },
    context: {
      usecaseId,
      responseType,
      vsLoader: true,
      withLoader: false,
      ...externalContext
    },
    callback
  };
};
exports.executeAction = executeAction;
const exportReport = (usecaseId, format, callback) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "export",
    exportFormat: format
  },
  context: {
    usecaseId,
    responseType: "blob",
    vsLoader: true,
    withLoader: false,
    autoDownload: true
  },
  callback
});
exports.exportReport = exportReport;
const downloadFile = (usecaseId, autoDownload, callback) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "downloadFile"
  },
  context: {
    usecaseId,
    responseType: "blob",
    vsLoader: true,
    withLoader: false,
    autoDownload
  },
  callback
});
exports.downloadFile = downloadFile;
const confirmAction = function (usecaseId, tdlId) {
  let callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;
  return {
    type: GENERAL_ACTION_TYPES.SEND_REQUEST,
    options: {
      tdlId,
      isForced: true
    },
    context: {
      usecaseId,
      vsLoader: true
    },
    callback
  };
};
exports.confirmAction = confirmAction;
const askForPossibleValue = (usecaseId, callback, currentKeyFocus, currentKeyValue) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "getPVs",
    currentKeyFocus: currentKeyFocus,
    currentKeyValue: currentKeyValue
  },
  context: {
    usecaseId,
    vsLoader: false,
    withLoader: false
  },
  callback
});
exports.askForPossibleValue = askForPossibleValue;
const sendSearchRequest = function (usecaseId) {
  let callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
  return {
    type: GENERAL_ACTION_TYPES.SEND_REQUEST,
    options: {
      tdlId: "search",
      pageNumber: 0
    },
    context: {
      usecaseId,
      vsLoader: true,
      withLoader: false
    },
    callback
  };
};
exports.sendSearchRequest = sendSearchRequest;
const flipCountMode = (usecaseId, callback) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "flipCountMode"
  },
  context: {
    usecaseId,
    vsLoader: true,
    withLoader: false
  },
  callback
});
exports.flipCountMode = flipCountMode;
const getRowsCount = usecaseId => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "getRowsCount"
  },
  context: {
    usecaseId,
    vsLoader: true,
    withLoader: false
  }
});
exports.getRowsCount = getRowsCount;
const applyFilter = usecaseId => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "applyFilter"
  },
  context: {
    usecaseId,
    vsLoader: true,
    withLoader: false
  }
});
exports.applyFilter = applyFilter;
const deleteFilter = (usecaseId, callback) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "deleteFilter"
  },
  context: {
    usecaseId,
    vsLoader: true,
    withLoader: false
  },
  callback
});
exports.deleteFilter = deleteFilter;
const saveFilter = (usecaseId, callback) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "saveFilter"
  },
  context: {
    usecaseId,
    vsLoader: true,
    withLoader: false
  },
  callback
});
exports.saveFilter = saveFilter;
const addToFavorite = (usecaseId, callback) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "addToFavorite"
  },
  context: {
    usecaseId,
    vsLoader: true,
    withLoader: false
  },
  callback
});
exports.addToFavorite = addToFavorite;
const removeFromFavorite = (usecaseId, callback) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "removeFromFavorite"
  },
  context: {
    usecaseId,
    vsLoader: true,
    withLoader: false
  },
  callback
});
exports.removeFromFavorite = removeFromFavorite;
const sendNewCollectionElement = (usecaseId, callback) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "newCollectionElement"
  },
  context: {
    usecaseId,
    vsLoader: true,
    withLoader: false
  },
  callback
});
exports.sendNewCollectionElement = sendNewCollectionElement;
const cancelCollectionElement = (usecaseId, callback) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "cancelCollectionElement"
  },
  context: {
    usecaseId,
    vsLoader: true,
    withLoader: false
  },
  callback
});
exports.cancelCollectionElement = cancelCollectionElement;
const requestCheckIntegrity = (usecaseId, callback) => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "integrityCheck"
  },
  context: {
    usecaseId,
    vsLoader: true,
    withLoader: false
  },
  callback
});
exports.requestCheckIntegrity = requestCheckIntegrity;
const fetchFavoriteList = () => ({
  type: GENERAL_ACTION_TYPES.SEND_REQUEST,
  options: {
    tdlId: "CMS$$CMS$$-$$favouriteMenu",
    pageNumber: 0,
    rowsNumber: 1000000
  },
  context: {
    withLoader: false,
    closeUsecase: true
  }
});
exports.fetchFavoriteList = fetchFavoriteList;
const uploadFile = function (usecaseId, file, path) {
  let callback = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
  return {
    type: GENERAL_ACTION_TYPES.UPLOAD_FILE,
    usecaseId,
    file,
    path,
    callback
  };
};
exports.uploadFile = uploadFile;