"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _general = require("../actions/general");
const INITIAL_STATE = {
  isLoading: false,
  customLoading: false,
  isRTL: true,
  timeZoneOffset: null,
  currentUser: null,
  isSessionInvalidated: true,
  sidebarCollapsed: true,
  mainMenu: [],
  favorite: [],
  errors: []
};
var _default = exports.default = function _default() {
  let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : INITIAL_STATE;
  let action = arguments.length > 1 ? arguments[1] : undefined;
  console.log("actions is ", action);
  switch (action.type) {
    case _general.GENERAL_ACTION_TYPES.SET_ERRORS:
      console.log("reducing error");
      return {
        ...state,
        errors: action.errors
      };
    case _general.GENERAL_ACTION_TYPES.SET_WARNINGS:
      console.log("reducing error");
      return {
        ...state,
        warnings: action.warnings
      };
    case _general.GENERAL_ACTION_TYPES.SET_SUCCESSFUL_MESSAGES:
      console.log("reducing error");
      return {
        ...state,
        successfulMessages: action.successfulMessages
      };
    case _general.GENERAL_ACTION_TYPES.SET_IS_LOADING:
      return {
        ...state,
        isLoading: action.isLoading
      };
    case _general.GENERAL_ACTION_TYPES.SET_CUSTOM_LOADING:
      return {
        ...state,
        customLoading: action.customLoading
      };
    case _general.GENERAL_ACTION_TYPES.SET_TIMEZONE_OFFSET:
      return {
        ...state,
        timeZoneOffset: action.timeZoneOffset
      };
    case _general.GENERAL_ACTION_TYPES.SET_IS_RTL:
      return {
        ...state,
        isRTL: action.isRTL
      };
    case _general.GENERAL_ACTION_TYPES.SET_IS_SESSION_INVALIDATED:
      return {
        ...state,
        isSessionInvalidated: action.isSessionInvalidated
      };
    case _general.GENERAL_ACTION_TYPES.SET_CURRENT_USER:
      return {
        ...state,
        currentUser: action.currentUser
      };
    case _general.GENERAL_ACTION_TYPES.SET_SIDEBAR_COLLAPSED:
      return {
        ...state,
        sidebarCollapsed: action.sidebarCollapsed
      };
    case _general.GENERAL_ACTION_TYPES.SET_MAIN_MENU:
      return {
        ...state,
        mainMenu: action.mainMenu
      };
    case _general.GENERAL_ACTION_TYPES.SET_FAVORITE_ITEMS:
      return {
        ...state,
        favorite: action.favorite
      };
    default:
      return state;
  }
};